// For construction new question objects
function question(answer, support, question, a, b, c, d) {
	this.answer = answer;
	this.support = support;
	this.question = question;
	this.a = a;
	this.b = b; 
	this.c = c;
	this.d = d;
	return this;
	}

// The array of questions, answers, options, and explanations
var units = new Array(
	new question("b", "The <FONT FACE=Courier>body</FONT> property is completely contrived. All the others are valid.", "Choose the property that does not belong to the Mail Message object for Netscape Messenger:", "folder", "body", "read", "priority"),
	new question("c", "Methods <FONT FACE=Courier>trash()</FONT> and <FONT FACE=Courier>killThread()</FONT> seem likely candidates, but the culprit is actually <FONT FACE=Courier>filter()</FONT>", "Choose the method that does not belong to the Mail Message object for Netscape Messenger:", "killThread()", "watchThread()", "filter()", "trash()"),
	new question("a", "When you call a dialog box, the current window loses focus. As soon as you choose a dialog button such as <FONT FACE=Courier>OK</FONT> or <FONT FACE=Courier>Cancel</FONT>, the dialog box will be recalled..... ad infinitum.", "Which of the following is a known JavaScript bug?", "Using window.alert, window.confirm or window.prompt inside onFocus handlers can cause infinite loops", "Using window.alert, window.confirm or window.prompt inside onBlur handlers can cause infinite loops", "Using window.alert, window.confirm or window.prompt inside onLoad handlers can cause infinite loops", "Using window.alert, window.confirm or window.prompt inside onFocus handlers can cause infinite loops"),
	new question("a", "<FONT FACE=Courier>link()</FONT> arrived in 1.0; <FONT FACE=Courier>split()</FONT> and <FONT FACE=Courier>join()</FONT> showed up in 1.1", "Select the method added in JavaScript 1.2:", "concat()", "link()", "split()", "join()"),
	new question("b", "<FONT FACE=Courier>slice()</FONT> came about in version 1.2", "Select the method not supported by JavaScript 1.1:", "sort()", "slice()", "split()", "reverse()"),
	new question("b", "All the rest came about in 1.1", "Select the feature added in JavaScript 1.0:", "lowsrc", "link()", "split()", "join()"),
	new question("c", "The <FONT FACE=Courier>Function</FONT> constructor must evaluate its arguments each time it is called. This slows things a bit.", "What is one disadvantage of using the Function constructor?", "Scripts can use it to create functions at run time", "It conveniently defines small functions", "Functions defined this way are not compiled and execute slower", "There is no reason not to use it"), 
	new question("d", "<FONT FACE=Courier>arguments</FONT> is an array containing the arguments passed. <FONT FACE=Courier>arity</FONT> returns the number of arguments expected. <FONT FACE=Courier>caller</FONT> identifies the calling function.", "Which doesn't belong to the Function constructor?", "arguments", "arity", "caller", "id"),
	new question("c", "<FONT FACE=Courier>find()</FONT> accepts zero, one, or three arguments, but not two.", "Choose the bogus call to the find() method:", "find()", "find(string)", "find(string, matchcase)", "find(string, matchcase, backward)"),
	new question("b", "This property identifies plug-in paths.", "Which object is the proud owner of the filename property:", "document", "Plugin", "FileUpload", "Window"),
	new question("a", "You must use the same &; notation as you do for HTML character entities.", "Which is the proper syntax for using JavaScript entities?", "&lt;TD WIDTH=&{myVar};>", "&lt;TD WIDTH=100>The answer is &{myVar}&lt;/TD>", "&lt;&{myVar} WIDTH=100>", "All of them are fine"), 
	new question("a", "<FONT FACE=Courier>id</FONT> is the object property to monitor. <FONT FACE=Courier>handler</FONT> identifies the function to call when <FONT FACE=Courier>id</FONT> changes.", "Which is the correct syntax for the watch() method?", "watch(id, handler)", "watch(handler, id)", "watch(id)", "watch(handler)"), 
	new question("c", "These properties were replaced by <FONT FACE=Courier>outerWidth</FONT> and <FONT FACE=Courier>outerHeight</FONT>, respectively.", "Choose the properties that have been deprecated as of JavaScript 1.2", "window.width", "window.height", "Both a and b", "Neither a nor b"),
	new question("d", "All of them would become true by exchanging <I>Double</I> for <I>Float</I>, <I>stay wrapped</I> for <I>become unwrapped</I>, and <I>unwrapped</I> for <I>wrapped</I>. Kind of dirty, huh?", "Think LiveConnect. Which is true of data type conversion for values passed from JavaScript to Java?", "Strings, numbers and booleans are converted to Java String, Double, and Boolean objects", "Objects that are wrappers around Java objects stay wrapped", "Other objects are unwrapped with a JSObject", "Something stinks. I say they're all wrong"), 
	new question("c", "The comma operator would evaluate the second expression.", "Consider the following array:<BR><BR>var opposites = new Array(new Array('Day', 'Night'),<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;new Array('Good', 'Evil'),<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;new Array('Right', 'Wrong')<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;);<BR><BR>What does the following print? <BR><BR>document.write(opposites[1,2]);", "['Right', 'Wrong']", "['Day', 'Night']", "Wrong", "undefined"),
	new question("c", "Technically, <FONT FACE=Courier>with</FONT> is a JavaScript reserved word used in statements.", "Which of the following is not an operator?", "comma", "ternary", "with", "void"),
	new question("c", "When using bitwise operators to evaluate multiple expressions (e.g., <FONT FACE=Courier>(i > 6 & g < 7)</FONT> ), if the first is false, the remaining expressions are not evaluated.", "Which uses short-circuit evaluation?", "watch()", "unwatch()", "bitwise operators", "assignment operators"),
	new question("d", "Microsoft Internet Explorer 4.x supports the <FONT FACE=Courier>document.all</FONT> object. Netscape Navigator does not.", "Which might you use for browser detection?", "document.location", "document.domain", "document.layer", "document.all"),
	new question("a", "The <FONT FACE=Courier>watch()</FONT> method in a sense owns its own thread, and does monopolize other processes.", "What is arguably the most resource-efficient way to monitor an object property until it has changed?", "watch()", "setTimeOut()", "setInterval()", "a while loop"),
	new question("d", "This will strap your processing power in the browser, and not free it up until the object property has changed.", "What is arguably the most resource-inefficient way to monitor an object property until it has changed?", "watch()", "setTimeOut()", "setInterval()", "a while loop"),
	new question("d", "<FONT FACE=Courier>void</FONT> has the syntax of a method or function, but it is an operator.", "Which best describes <I>void</I>?", "A method", "A function", "A statement", "An operator"),
	new question("a", "Object signing requires the the signature and other files be stored in a Java Archive (JAR) file.", "Which JavaScript feature uses JAR files?", "Object signing", "Style sheets", "Netcaster channels", "Image rollovers"),
	new question("d", "The <FONT FACE=Courier>charAt()</FONT> method of the <FONT FACE=Courier>String</FONT> object is supported in JavaScript 1.0, which MSIE 3.x supports.", "Which feature is supported in MSIE 3.x?", "split()", "Image()", "join()", "charAt()"),
	new question("a", "If you do not set the <FONT FACE=Courier>expires</FONT> attribute, the cookie expires at the end of the browser session.", "What's the default setting for the <I>expires</I> attribute of the document.cookie property?", "The duration of the browser session.", "The duration the current document stays loaded.", "Twenty-four hours from the time the cookie is set.", "There is no default setting."),
	new question("a", "The <FONT FACE=Courier>onKeyDown</FONT> event must first return true before the <FONT FACE=Courier>onKeyPress</FONT> event will be considered.", "Which of the following is true?", "If onKeyDown returns false, the key-press event is cancelled.", "If onKeyPress returns false, the key-down event is cancelled.", "If onKeyDown returns false, the key-up event is cancelled.", "If onKeyPress returns false, the key-up event is canceled."),
	new question("c", "JavaScript employs prototype-based inheritance, which helps qualify it as an object-oriented language.", "Which is true of JavaScript?", "JavaScript is not object oriented", "JavaScript employs class-based inheritance", "JavaScript employs prototype-based inheritance", "JavaScript supports pointers"),
	new question("c", "The <FONT FACE=Courier>FileUpLoad</FONT> object belongs to client-side JavaScript", "Choose the server-side JavaScript object:", "FileUpLoad", "Function", "File", "Date"),
	new question("d", "The <FONT FACE=Courier>File</FONT> object belongs to server-side JavaScript.", "Choose the client-side JavaScript object:", "Database", "Cursor", "Client", "FileUpLoad"),
	new question("a", "Though the same <FONT FACE=Courier>setTimeout()</FONT> method can be called multiple times, it only runs its statements once.", "Seek the truth about setTimeout():", "The statement(s) it executes run(s) only once.", "It pauses the script in which it is called.", "clearTimeOut() won't stop its execution.", "The delay is measured in hundredths of a second."),
	new question("b", "The other three are either read-only or bogus.", "What property would you use to redirect a visitor to another page?", "document.URL", "window.location.href", ".document.location.href", "link.href"),
	new question("c", "<FONT FACE=Courier>getSelection()</FONT> returns a copy of the text you have highlighted.", "Which best explains getSelection()?", "Returns the VALUE of a selected OPTION.", "Returns document.URL of the window in focus.", "Returns the value of cursor-selected text.", "Returns the VALUE of a checked radio input."),
	new question("d", "Sneaky, but true.", "navigator.platform indicates 'Win16', but you are running Win NT. What gives?", "Impossible. This is a sick joke.", "The userAgent property reflects the correct OS.", "The property can be modified.", "navigator.platform shows the OS for which the browser was compiled."),
	new question("d", "Using the <FONT FACE=Courier>preference()</FONT> method requires that the user grant permission based on credentials of the owner contained in the signed script.", "You unsuccessfully use navigator.preferences() to alter browser preferences. How come?", "You\'re using export instead of import.", "You\'re using import instead of export.", "That\'s the wrong method.", "You\'re not using a signed script."),
	new question("b", "The <FONT FACE=Courier>delete</FONT> operator was added in JavaScript 1.2.", "How do you delete an element from an array with JavaScript 1.2?", "Set it to false.", "Use the delete operator.", "Set it to undefined.", "Set it to -1."),
	new question("c", "All the other properties are assignable.", "Choose the read-only property:", "images[index].src", "layers[index].right", "layers[index].parentLayer", "links[index].target"),
	new question("c", "substring() accepts as many as two arguments- the first character index to copy and the last character index to copy. <FONT FACE=Courier>substr()</FONT> also accepts the first argument as the first character index to copy, but accepts a string length as the second argument.", "How do substring() and substr() differ?", "One is not a method of the String object.", "substr() takes three arguments, substring() only two.", "Only one accepts a desired string length as an argument.", "Besides the spelling, nothing."),
	new question("a", "Completely invented. Not to be confused with <FONT FACE=Courier>String</FONT> object method <FONT FACE=Courier>fromCharCode()</FONT>.", "What\'s wrong with this: var charConvert = atCharCode('x');", "atCharCode() is a bogus method.", "Nothing. I use it all the time.", "atCharCode accepts only numbers.", "atCharCode takes no arguments."),
	new question("d", "The <FONT FACE=Courier>Checkbox</FONT> object has no constructor.", "Choose the external object:", "Date", "Option", "Layer", "Checkbox"),
	new question("b", "The other three are external objects.", "Choose the built-in object:", "Password", "Math", "Link", "Hidden"),
	new question("b", "<FONT FACE=Courier>exec()</FONT> is a method of the <FONT FACE=Courier>RegExp</FONT> object. The other three are available to all objects.", "Which is not a global object method?", "toString()", "exec()", "typeOf()", "eval()"),
	new question("b", "JavaScript considers a variable with a null value equal to zero", "What is the equivalent of null in a JavaScript arithematic operation?", "NaN", "zero", "undefined", "false"),
	new question("c", "How many times have you seen this happen in a JavaScript error?", "Which would JavaScript assign to an uninitialized variable?", "NaN", "null", "undefined", "false"),
	new question("b", "<FONT FACE=Courier>this</FONT> is technically a built-in object.", "Which is not considered a JavaScript operator?", "new", "this", "delete", "typeof"),
	new question("a", "None of the others really comes close.", "Choose the best pattern for the string: 840-21-3688", "/\\d+-\\d{2,}-?\\d*/   /*", "/\\w+-\\w+-\\w+/", "/\\d+\\d+\\d+/", "/\\d+-\\d?-\\d+/"),
	new question("a", "The others are external objects.", "Choose the built-in JavaScript object:", "Image", "mimeType", "Password", "Area"),
	new question("a", "The other three have constructors.", "Choose the external object:", "Hidden", "Option", "Layer", "Function"),
	new question("b", "<FONT FACE=Courier>prototype</FONT> is a property, not a method.", "How would you add a property to an object class?", "With the prototype() method.", "With the prototype property.", "Sorry. Can\'t be done.", "With the this object."),
	new question("d", "<FONT FACE=Courier>arguments.length</FONT> returns the actual number of arguments received, not the number expected.", "Which property returns the number of arguments expected by a function?", "arguments.length", "Function.caller", "Function.display", "Function.arity"),
	new question("c", "The word program sounds good, but is not reserved.", "Which is not a reserved word?", "interface", "short", "program", "throws"),
	new question("a", "<FONT FACE=Courier>enabledPlugin</FONT> returns a reference to the plugin object that supports the corresponding MIME type (if it is installed).", "Select the property that doesn't hold a Boolean value:", "MimeType.enabledPlugin", "option.defaultSelected", "form.reset.enabled", "image.complete"),
	new question("c", "Even if you pass nothing, <FONT FACE=Courier>open()</FONT> has a hunch that you will be writing HTML.", "What\'s the default string passed to document.open()?", "application/pdf", "image/gif", "text/html", "text/plain"),
	new question("b", "LiveConnect permits communication among JavaScript, Java, and plug-ins.", "What allows JavaScript to access methods and properties of a Java applet?", "The Java console", "LiveConnect", "LiveWire", "LiveWire Pro"),
	new question("b", "<FONT FACE=Courier>domain</FONT> yes; <FONT FACE=Courier>host</FONT> no.", "Which is not an attribute of the cookie property?", "path", "host", "secure", "domain"),
	new question("b", "If you want to split hairs, you can also not assign the <FONT FACE=Courier>expiry</FONT> attribute and let the cookie die after the browser session.", "How do you delete a cookie?", "You can\'t. They\'re valid until they expire.", "Overwrite it with an expiry date in the past.", "escape() the value of the path attribute.", "unescape() the value of the path attribute."),
	new question("c", "All the others are simply untrue.", "Which cookies.txt filesize is too large?", "1K", "3K", "5K", "There is no theoretical limit."),
	new question("d", "This prevents the mischevious from storing gigabytes of information on your hard drive.", "What happens to the document.cookie data if it exceeds the maximum size?", "Your script automatically generates a run-time error.", "Your script automatically generates a load-time error.", "All processes using document.cookie are ignored.", "The cookie is truncated to the maximum length."),
	new question("b", "This only happens in nested tables. NN4.x corrects the problem.", "You\'ve embedded the document.write() method to write some text within a pair of &lt;TD&gt;&lt;/TD&gt; table tags. Upon loading the file, however, you get some garbled junk on the page where that text should be. What browser are you most likely using?", "MSIE 2.x", "Netscape Navigator 3.x", "Netscape Navigator 4 beta 2", "MSIE 3.02"),
	new question("a", "Choice b could go too high. Choice c does not return an integer. Choice d does not even access the array", "How would you randomly choose an element from an array named myStuff if the number of elements changes dynamically?", "randomElement = myStuff[Math.floor(Math.random() * myStuff.length)];", "randomElement = myStuff[Math.ceil(Math.random() * myStuff.length)];", "randomElement = myStuff[Math.random(myStuff.length)];", "randomElement = Math.random(myStuff.length);"),
	new question("d", "Both work well for 3.x browsers.", "With the advent of JavaScript1.2, the String.replace() method facilitates character replacement in strings. How would you remove every \'x\' from the variable myString without the new features of 1.2?", "for(var i = 0; i < myString.length; i++) {<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(myString.charAt(i) != \'x\') {<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;myStringCopy += myString.charAt(i);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;myString = myStringCopy;", "var myArray = myString.split(\'x\'); myString = myArray.join(\'\');", "It wasn't possible until now. Thanks JavaScript1.2\!", "The first two both work fine."),
	new question("a", "If you do not include MAYSCRIPT in the APPLET tag, LiveConnect cannot do its thing.", "What HTML attribute allows a Java applet explicit permission to access JavaScript objects and functions?", "MAYSCRIPT", "CODE", "PARAM", "CODEBASE"),
	new question("b", "Another contrived item. Oh, the humanity.", "Which is not a package of the Java class hierarchy available in Navigator?", "netscape", "javasoft", "sun", "java"),
	new question("a", "They are all there, but only choice a has the correct order.", "Choose the four symbol pairs that represent RegExp properties lastMatch, lastParent, leftContext, and rightContext, respectively:", "$&, $+, $`, $'", "$+, $&, $', $`", "$&, $~, $`, $'", "$+, $&, $`, $'"),
	new question("b", "<FONT FACE=Courier>pattern.global</FONT> returns a Boolean value indicating if the regular expression performs global (all) matches in a string.", "Consider three variables: <BR><BR><BLOCKQUOTE>someText = 'JavaScript1.2';<BR>pattern = /(\\w+)(\\d)\\.(\\d)/i;<BR>outCome = pattern.exec(someText);</BLOCKQUOTE><BR>What does pattern.global contain?", "true", "false", "undefined", "null"),
	new question("a", "<FONT FACE=Courier>pattern.ignoreCase</FONT> returns a Boolean value indicating if the regular expression performs case-sensitive matches.", "Consider three variables: <BR><BR><BLOCKQUOTE>someText = 'JavaScript1.2';<BR>pattern = /(\\w+)(\\d)\\.(\\d)/i;<BR>outCome = pattern.exec(someText);</BLOCKQUOTE><BR>What does pattern.ignoreCase contain?", "true", "false", "undefined", "null"),
	new question("c", "The only match is the string JavaScript1.2.", "Consider three variables: <BR><BR><BLOCKQUOTE>someText = 'JavaScript1.2';<BR>pattern = /(\\w+)(\\d)\\.(\\d)/i;<BR>outCome = pattern.exec(someText);</BLOCKQUOTE><BR>What does outCome[0] contain?", "true", "false", "JavaScript1.2", "null"),
	new question("a", "It does no harm, but looks weird.", "After clicking on a link, your main browser window spawns a small new window and writes some text to it. However, when viewing both window page sources, the small window page source is identical to that of the large. How can this be?", "The function writing to the new window didn\'t close the document stream.", "Gimme a break. It\'d never happen.", "Windows receive the source code of the window that wrote to them.", "Since the new window has no filename, it receives the source code of its parent."),
	new question("d", "Just another dirty ploy to make you choose from a group of wrong answers.", "Choose another way to write x ? a = b : a = c", "if (\'x\') { a = b; } else { a = c; }", "if (x) { a = c; } else { a = b; }", "x : a = c ? a = b", "All of these are bogus."),
	new question("c", "<FONT FACE=Courier>exec()</FONT> belongs to the <FONT FACE=Courier>RegExp</FONT> object.", "Which of these is not a method of the Math object?", "atan()", "atan2()", "exec()", "acos()"),
	new question("a", "How do you give a hidden field focus, anyway?", "Choose the object associated with the onFocus event handler:", "Password", "Hidden", "Both", "Neither"),
	new question("a", "The <FONT FACE=Courier>window</FONT> object does not listen for it.", "Choose the object associated with the onMouseOut event handler:", "Layer", "Window", "Both", "Neither"),
	new question("a", "You can load documents into <FONT FACE=Courier>Layer</FONT>s all day, but onUnLoad never happens.", "Choose the object associated with the onUnLoad event handler:", "Window", "Layer", "Both", "Neither"),
	new question("d", "Neither is associated with <FONT FACE=Courier>onBlur</FONT>.", "Choose the object associated with the onBlur event handler:", "Image", "Document", "Both", "Neither"),
	new question("a", "Only the <FONT FACE=Courier>document</FONT> object is associated.", "Choose the object associated with the onKeyPress event handler:", "document", "Layer", "Both", "Neither"),
	new question("a", "The <FONT FACE=Courier>type</FONT> property would reveal that this is a multiple SELECT list.", "Consider the following HTML: <BR><BR>&lt;FORM&gt;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&lt;SELECT MULTIPLE&gt;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;OPTION&gt;This one<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;OPTION&gt;That one<BR>&nbsp;&nbsp;&nbsp;&nbsp;&lt;/SELECT&gt;<BR>&lt;/FORM&gt;<BR><BR>What does alert(document.forms[0].elements[0].type) display?", "select-multiple", "form element", "select", "multiple"),
	new question("b", "JavaScript is, in fact, a dynamically-typed language. So variable types can be changed on the fly.", "JavaScript does not support dynamic data typing.", "True", "False", "True as of JavaScript 1.2.", "False as of JavaScript 1.2.")
	);